//Copyright (C) 2004 Benito van der Zander
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "files.h"
#include "vmmwrap2.h"
//R0_FileInterface
#define MEMORYOPTIONS HEAPSWAP
const unsigned long monthLength[12]={31,29,31,30,31,30,31,    31,30,31,30,31};
short IFSR0FindFirstFile(short attributes, char * path, WIN32_FIND_DATAA * findResult, DWORD * handle)	{
  short result;
  DWORD outhan=54321;
  __asm{
    mov eax, R0_FINDFIRSTFILE 
    mov cx, attributes
    mov esi, path
    mov edx, findResult
    call IFSMgr_Ring0_FileIOWrap
    jc error
    //No Error
    mov result, 0
    jmp exit
    
    error:
    //Error
    mov result, ax       
          
    exit:
    mov outhan, eax
  }
  *handle=outhan;
  return result;
}
int IFSR0FindNextFile(WIN32_FIND_DATAA * findResult, DWORD handle)	{
  short result;
  __asm{
    mov eax, R0_FINDNEXTFILE 
    mov ebx, handle
    mov edx, findResult
    call IFSMgr_Ring0_FileIOWrap
    jc error
    //No Error
    mov result, 0
    jmp exit
    
    error:
    //Error
    mov result, ax             
    exit:
  } 
  return result;
}
int IFSR0FindCloseFile(DWORD handle) {
  short result;
  __asm{
    mov eax, R0_FINDCLOSEFILE  
    mov ebx, handle
    call IFSMgr_Ring0_FileIOWrap
    jc error
    //No Error
    mov result, 0
    jmp exit
    
    error:
    //Error
    mov result, ax             
    exit:
  }
  return result;
}
short IFSR0GetFileAttributes(char * fileName, short * attrib)	{
  short error;
  short result;
  __asm{
    xor cx, cx
    xor ax, ax
    mov eax, R0_FILEATTRIBUTES 
    mov al, GET_ATTRIBUTES 
    mov esi, fileName
    call IFSMgr_Ring0_FileIOWrap

    mov error, ax
    mov result, cx
  }
  *attrib=result;
  return error;
}
//see INT 0x21, SubFunction 0x6c *confusing*
DWORD IFSR0OpenFile(const char * fileNameESI, int openFunctionEAX, unsigned short openModeBX, unsigned short attribsCX, unsigned char actionDL, unsigned char optionsDH, DWORD * handle, unsigned short * action)	{
  DWORD handleOut=0;
  short errorCode=0;
  short error=0;
  short actionOut=0;
  __asm{
    mov eax, openFunctionEAX//R0_OPENCREATFILE //openFunctionEAX //RO_OPENCREAT_IN_CONTEXT 
    mov bx, openModeBX//0x3000//OPEN_ACCESS_READONLY (0000h) | OPEN_SHARE_COMPATIBLE (0000h) | EXTENDED_SIZE (1000h) | OPEN_FLAGS_NOCRITERR (2000h)
    mov cx, attribsCX//FILE_ATTRIBUTE_NORMAL
    mov dh, optionsDH
    mov dl, actionDL
    mov esi, fileNameESI
    call IFSMgr_Ring0_FileIOWrap
    jc errorj
      mov handleOut, eax
      mov actionOut, cx

      jmp exit

    errorj:
      mov errorCode, ax
      mov error, 1
    exit:
  }
  if (error!=0) {
    SimpleMessage("Open Error");
    *handle=errorCode;
    ShowIntMessage(MB_ASAP,errorCode,"error code:");
  } else {
    *handle = handleOut;
    if (action!=NULL) 
      *action=actionOut;
  }  
  return error;
}
int IFSR0CloseFile(DWORD handle){
  short result;
  __asm{
    mov eax, R0_CLOSEFILE 
    mov ebx, handle
    xor ax, ax //error code
    call IFSMgr_Ring0_FileIOWrap
    
    mov result, ax
  }  
  return result;
}  
short IFSR0ReadFile(DWORD handleEBX, int readFuncEAX, int readCountECX, int startPosEDX, char/*void*/ * bufferESI, int * result){
  short errorCode=0;
  int readed=0;
  __asm{
    xor ax, ax //error code 
    mov eax, readFuncEAX //readFuncEAX

    mov ebx, handleEBX
    mov ecx, readCountECX
    mov edx, startPosEDX
    mov esi, bufferESI
    call IFSMgr_Ring0_FileIOWrap
    jc error
      mov readed, ecx
      jmp exit
      
    error:
      or ax, 0x8000
      mov errorCode, ax
    
    exit:
  }
  *result=readed;
  return errorCode;
}  
//that is the same function as read file
short IFSR0WriteFile(DWORD handleEBX, int writeFuncEAX, int writeCountECX, int startPosEDX, char * bufferESI, int * result){
  return IFSR0ReadFile(handleEBX,writeFuncEAX,writeCountECX,startPosEDX,bufferESI,result);
}
short IFSR0GetFileSize(DWORD handleEBX,int * size){
  short error=0;
  int tsize=0;
  __asm{
    xor ax, ax
    mov eax, R0_GETFILESIZE
    mov ebx, handleEBX
    call IFSMgr_Ring0_FileIOWrap
    jc errorj
      mov tsize, eax
      jmp exit
      
    errorj:
      mov error, ax
      mov tsize, 0
    exit:
  }
  *size=tsize;
  return error;
}  
BOOL ExistDirectory(char * dir){
  _WIN32_FIND_DATA tempData;
  BOOL result=01;
  __asm{
    mov eax, R0_FINDFIRSTFILE 
    mov cx, 0
    mov esi, dir
    lea edx, tempData
    call IFSMgr_Ring0_FileIOWrap
    jc error
  
      mov ebx, eax
      mov eax, R0_FINDCLOSEFILE 
      call IFSMgr_Ring0_FileIOWrap
      jmp exit;
        
    error:
      mov result, 0
    
    exit:
  }
}
short GetFileSize(char * name,int * size){
  short error;
  WIN32_FIND_DATAA findData;
  DWORD han;
  if ((error=IFSR0FindFirstFile(FILE_ATTRIBUTE_EVERYTHING,name,&findData,&han))!=0)
    return error;
  if (han==0) return 1;
  *size=findData.nFileSizeLow;
  IFSR0FindCloseFile(han);
  return 0;
}  
short GetFileTimes(char * fileName, dos_time * access, dos_time * change, dos_time * create){
  short error;
  WIN32_FIND_DATAA findData;
  DWORD han;
  if ((error=IFSR0FindFirstFile(FILE_ATTRIBUTE_EVERYTHING,fileName,&findData,&han))!=0)
    return error;
  if (han==0) return 1;
  if (create!=NULL)
    Win32TimeToDosTime(&findData.ftCreationTime,create);
  if (access!=NULL)
    Win32TimeToDosTime(&findData.ftLastAccessTime,access);
  if (change!=NULL)
    Win32TimeToDosTime(&findData.ftLastWriteTime,change);
  IFSR0FindCloseFile(han);
  return 0;
} 

//IFS Interface
pIFSFileHookFunc IFSMgr_InstallFileSystemApiHookCWrap(pIFSFileHookFunc newFunc){
  pIFSFileHookFunc result;
  __asm {
    mov eax, newFunc
    call IFSMgr_InstallFileSystemApiHookWrap;
    mov result, eax
  }
  return result;
}
void IFSMgr_RemoveFileSystemApiHookCWrap(pIFSFileHookFunc func){
  __asm {
    mov eax, func
    call IFSMgr_RemoveFileSystemApiHookWrap;
  }
}

//Converter/Pathfuncs
int UniToBCSPathCWrap(char * pBCSPath, ParsedPath * pUniPath, unsigned int maxLength, int charSet) { 
   int res;
  __asm{  
    push esi //Save
    push edi
  
    
    mov eax, charSet
    mov ecx, maxLength
    mov esi, pUniPath
    add esi, 4
    mov edi, pBCSPath
    
    call UniToBCSPathWrap
    
    mov res, eax

     //Free arguments
    pop esi //restore
    pop edi
    
  }
  //SimpleMessage(pBCSPath);
  return res;
}
void BCSToUniPath(char * bcs, ParsedPath ** uni, BOOL swapable){
  unsigned short i,tempLen,bcsLen,uniLen, backSpace/*,slashes*/=0;
  unsigned short * mover;
  unsigned short * actSize;
  if (bcs[2]!='\\') bcsLen=0;
  else {
    bcs+=3; //x:\ isn't neaded
    for (bcsLen=0;bcs[bcsLen]!='\0';bcsLen++); //get the length //and counts the backslashes
  }  
  if (bcsLen>0) {//more than root
    //for every char, we need an unsigned short unicode character ('\\'->length)
    uniLen=4+2+bcsLen*2;//plus the start length and offset (without \0)

    if (swapable)
      *uni=(ParsedPath*)halloc(uniLen+2,HEAPSWAP);
     else 
      *uni=(ParsedPath*)halloc(uniLen+2,0);
    (*uni)->pp_totalLength=uniLen;

    BCSToUniCWrap(bcs-1,(unsigned short*)&((*uni)->pp_elements[0]),bcsLen+1,BCS_WANSI);
    backSpace=*(unsigned short*)&(((*uni)->pp_elements[0]));
    tempLen=2;
    mover=(unsigned short*)*uni;
    actSize=&((*uni)->pp_elements[0].pe_length);
    for (i=3;i<(uniLen/2);i++) 
      if (mover[i]==backSpace) {
        *actSize=tempLen;
        actSize=&mover[i];
        tempLen=2;
      } else {tempLen+=2;}  
    *actSize=tempLen;
    (*uni)->pp_prefixLength=(unsigned short)((unsigned int)actSize-(unsigned int)(*uni));
    ((char*)(*uni))[uniLen]=0;
    ((char*)(*uni))[uniLen+1]=0;
  } else {
    //only root path
    *uni=(ParsedPath*)halloc(8,HEAPSWAP);
    (*uni)->pp_totalLength=6;
    (*uni)->pp_prefixLength=4;
    (*uni)->pp_elements[0].pe_length=0;
    ((char*)(*uni))[6]=0;
    ((char*)(*uni))[7]=0;
  }  
}  
BOOL isDOSPath(ParsedPath * ppath){
  PathElement *pele;
  int i;
  BOOL point=FALSE;
  for (pele=&ppath->pp_elements[0];
       (int)pele<(int)ppath+(int)ppath->pp_prefixLength;
       pele=(PathElement*)((int)pele+(int)pele->pe_length))
     if (pele->pe_length>8) return FALSE; //dir name must be less than 8
  //pele is now the last element
  if (pele->pe_length>12) return FALSE; //no file is so long
  if (pele->pe_length<=8) {
    //count points, a dos name has only one
    for (i=0;pele->pe_unichars[i]!=0;i++) 
      if (pele->pe_unichars[i]==(short)'.'){
        if (point) return FALSE; //to much points
        point=TRUE;
      }  
    return TRUE; //less ok, for file and dir
  }  
  
  for (i=0;pele->pe_unichars[i]!=0;i++) 
    if (pele->pe_unichars[i]==(short)'.'){
      if (point) return FALSE;//to much points
      if (i<8) return FALSE; //to early
      point=TRUE;
    }  
  return point; //if file, ok
}  
BOOL convertLastLFNElementToDOS(char * bcsInPath, char ** bcsOutPath, BOOL swapable){
  //Konvertiert einen LFN Path in a normal DOS Path
  //use R0_FindFile, not fast, but it goes always, if the find routines are programmed
  
  int len,pos,i,j;
  int error;
  WIN32_FIND_DATAA findData;
  DWORD handle;
  ULONG memFlags=swapable?HEAPSWAP:0;
  for (len=0;bcsInPath[len]!='\0';len++);
  if (len==3) {//only root path
    *bcsOutPath=(char*)halloc(3,memFlags);
    copyMemory(bcsInPath,*bcsOutPath,3);
    return TRUE;
  } else {
    char * tempPath=(char*)halloc(len+2,memFlags);
    char * tempPath2=(char*)halloc(len+2,memFlags);
    *bcsOutPath=NULL;
    if ((tempPath==0)||(tempPath2==0)) return FALSE;
    copyMemory(bcsInPath,tempPath,len+1);
    pos=0;
    i=len;
    while (i>3) {
      tempPath2[pos]='\\';
      tempPath2[++pos]='\0';
      tempPath[i]='\0';
      if ((error=IFSR0FindFirstFile(FILE_ATTRIBUTE_EVERYTHING /*FILE_ATTRIBUTE_ARCHIVE|FILE_ATTRIBUTE_DIRECTORY|FILE_ATTRIBUTE_SYSTEM|FILE_ATTRIBUTE_HIDDEN|FILE_ATTRIBUTE_READONLY*/
            ,tempPath,&findData,&handle))!=0){
        showMessage(MB_ASAP,"not found",tempPath); 
        ShowIntMessage(MB_ASAP,error,tempPath); 
        hfree((ULONG)tempPath);
        hfree((ULONG)tempPath2);
        return FALSE;
      }  
      IFSR0FindCloseFile(handle);
      if (findData.cAlternateFileName[0]==0) //only lfn name 
        copyMemory(&findData.cFileName[0],&tempPath2[pos],14);
       else 
        copyMemory(&findData.cAlternateFileName[0],&tempPath2[pos],14);
      for (;(tempPath2[pos]!=0)&&(pos<len);pos++);
      for (i=len;i>0;i--) if (tempPath[i]=='\\') break;
    }  
    len=pos;
    *bcsOutPath=(char*)halloc(len,memFlags);
    copyMemory(bcsInPath,*bcsOutPath,3);  //
    pos=3;
    j=0;
    for (i=len-1;i>=0;i--)
      if (tempPath2[i]=='\\'){
        copyMemory(&tempPath2[i+1],&((*bcsOutPath)[pos]),j);
        pos+=j+1;
        (*bcsOutPath)[pos-1]='\\';
        j=0;
      } else j++; 
    (*bcsOutPath)[pos-1]='\0';
    hfree((ULONG)(tempPath));
    hfree((ULONG)(tempPath2));
  }  
  return TRUE;
}  
BOOL convertLastLFNElementToDOSUni(ParsedPath * inpp,ParsedPath ** outpp, int drive){
  char *temp;
  char *temp2=(char*)halloc(255,MEMORYOPTIONS);
  UniToBCSPathDrive(temp2, inpp,255,BCS_WANSI,drive);
  convertLastLFNElementToDOS(temp2,&temp,TRUE);
  BCSToUniPath(&temp2[0],outpp,TRUE);
  hfree((ULONG)temp);
  hfree((ULONG)temp2);
  return TRUE;
}  

int UniToBCSPathDrive(char * pBCSPath, ParsedPath * pUniPath, unsigned int maxLength, int charSet, int drive) { 
  pBCSPath[0]=(char)drive+'A'-1;
  pBCSPath[1]=':';
  return UniToBCSPathCWrap(pBCSPath+2,pUniPath, maxLength-2,charSet);
}

void cpyAnsiFindDataToUni(const WIN32_FIND_DATAA *in, _WIN32_FIND_DATA * out){
  out->dwFileAttributes=in->dwFileAttributes;
  out->ftCreationTime=in->ftCreationTime;
  out->ftLastAccessTime=in->ftLastAccessTime;
  out->ftLastWriteTime=in->ftLastWriteTime;
  out->nFileSizeHigh=in->nFileSizeHigh;
  out->nFileSizeLow=in->nFileSizeLow;
  out->cFileName[BCSToUniAuto( &in->cFileName[0],&out->cFileName[0])+1]='\0';
  BCSToUniAuto( &in->cAlternateFileName[0],&out->cAlternateFileName[0]);
}

void Win32TimeToDosTime(_FILETIME * w32in, dos_time * dosOut){
  unsigned int sec, min, hours=0;
  unsigned int day, month, year=1601;
  unsigned long tage;
  number64 w32time;

  w32time.low=w32in->dwLowDateTime;
  w32time.high=w32in->dwHighDateTime;
  
  n64Div32(&w32time,10*1000); //seconds
  sec=(w32time.low % 60) / 2; 
  n64Div32(&w32time,60); //min
  min=(w32time.low % 60);
  n64Div32(&w32time,60); //hour
  hours=(w32time.low % 24);
  
  //days since Jan 1, 1601   in w32time.low
  while (1) {
    if ((year % 4) == 0) {
      if ((year % 100) == 0) { 
        if ((year % 400) == 0) { 
          tage=366;
        }  else tage=365;
      } else tage = 366;  
    } else tage=365;
    if (w32time.low>tage) w32time.low-=tage;
    else break;
    year++;
  }  
  year-=1980; //dos stores since 1980
  month=0;
  while (w32time.low>monthLength[month]) {
    w32time.low-=monthLength[month];
    month++;
  }
  month--;
  day=w32time.low+1;
  
  dosOut->dt_time=(unsigned short)(sec + (min<<5) + (hours<<11));
  dosOut->dt_date=(unsigned short)(day + (month << 5) + (year<<9));
}  
