//Copyright (C) 2004 Benito van der Zander
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#include <basedef.h>
#include <VXDWRAPS.H>
#include <vmm.h>
#include <minivdd.H>
#include <shell.h>

#define rh_t DWORD
#define fh_t DWORD

#include <ifs.h>

#include <vwin32.h>

#include "vmmwrap2.h"
#include "files.h"
#define MEMORYOPTIONS HEAPSWAP
typedef struct tagFileHandle {
  DWORD r0handle;
  DWORD size;
  dos_time accessTime; 
  dos_time writeTime; 
  dos_time createTime; 
} FileHandle;

char mountDrive;
char redirDrive;
DWORD driveNameLen=0;
char driveName[32]="\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

pIFSFileHookFunc oldHook;
DWORD mutex;
DWORD logFile;

hndlmisc fileopenfuncs;
hndlmisc findfirstfuncs;

void UniToRedirPath(ParsedPath * pUniPath, char ** redirPath){
  *redirPath=(char*)halloc(255,MEMORYOPTIONS);
  UniToBCSPathDrive(*redirPath,pUniPath,255,BCS_WANSI,redirDrive);
}  

void writeLogFile(const char * message, int len);

#ifdef DEBUG
void initLogFile(const char * fileName){
  int error=IFSR0OpenFile(fileName,R0_OPENCREATFILE,2|0x40|0x3000|0x4000,0,0x10|0x1,0/*R0_NO_CACHE>>8*/,&logFile,NULL);
  if ((error!=0)||(logFile==0)) SimpleMessage("Can't open log file");
}
void writeLogFile(const char * message, int len){
  int size,temp;
  char * storedMes;
  if (IFSR0GetFileSize(logFile,&size)!=0){
    SimpleMessage("can't get size");
    return;
  }  
  storedMes=(char*)halloc(len+2,0);
  if (storedMes==0){
    SimpleMessage("can't get mem");
    return;
  }  
  for (temp=0;temp<len;temp++) storedMes[temp]=message[temp];
  storedMes[len]='\xD';
  storedMes[len+1]='\xA';
  if (IFSR0WriteFile(logFile,R0_WRITEFILE,len+2,size,storedMes,&temp)!=0) {
    SimpleMessage("can't write");
    return;
  }  
  hfree((ULONG)storedMes);
}  
void closeLogFile(){
  if (IFSR0CloseFile(logFile)!=0) SimpleMessage("can't close");
}    
#else
#define initLogFile(a)
#define writeLogFile(a,b)
#define closeLogFile()
#endif
int _cdecl FS_ErrorFunc(pioreq pir){
  showMessage(MB_OK,"Error Function called (I think that is an error, isn't)","CDRSim Error func");
  pir->ir_error=1;
  return pir->ir_error;
}
int  _cdecl FS_FindNextFile( pioreq pir ){
  WIN32_FIND_DATAA findData;


  pir->ir_error=(short)(IFSR0FindNextFile(&findData,(DWORD)pir->ir_fh));
  if (pir->ir_error==0) 
    cpyAnsiFindDataToUni(&findData,((_WIN32_FIND_DATA*)pir->ir_data));
  
  return pir->ir_error;
}
int __cdecl FS_FindFirstFile(pioreq pir ){
  WIN32_FIND_DATAA findData;
  DWORD handle;
  char * redirPath;
  writeLogFile("enter first file",16);
  //get path
  UniToRedirPath(pir->ir_ppath,&redirPath);

  //search
  pir->ir_error=(short)IFSR0FindFirstFile((short)pir->ir_attr,&redirPath[0],&findData,&handle);
  //return
  if (pir->ir_error==0) {
    (DWORD)(pir->ir_fh)=handle;
    pir->ir_hfunc->hf_read=&FS_FindNextFile;
    pir->ir_hfunc->hf_write=&FS_ErrorFunc;
    pir->ir_hfunc->hf_misc=&findfirstfuncs;/*->hm_revision=0;
    pir->ir_hfunc->hf_misc->hm_size=0;*/
    pir->ir_pos=NULL;
  }  
  cpyAnsiFindDataToUni(&findData,((_WIN32_FIND_DATA*)pir->ir_data));
  
  hfree((ULONG)redirPath);
  writeLogFile("leave first file",16);
  return pir->ir_error;
}
int  _cdecl FS_FindClose( pioreq pir ){
  writeLogFile("enter file close",16);
  IFSR0FindCloseFile((DWORD)pir->ir_fh);
  writeLogFile("leave file close",16);
  pir->ir_error=0;
  return 0;
}
int _cdecl FS_EnumHandle( pioreq pir ){
        showMessage(MB_OK  | MB_SYSTEMMODAL | MB_ICONEXCLAMATION | MB_ASAP ,"FS_EnumHandle","CRS debug");
        pir->ir_error=1;
  return pir->ir_error;
}
int FS_QueryResourceInfo(pioreq pir){
  SimpleMessage("FS_QueryResourceInfo ");
  if (pir->ir_options==2) {
    cpyStrN(pir->ir_data,&driveName[0],min(pir->ir_length,driveNameLen));
  }
  return pir->ir_error;
}
int FS_SearchFile(pioreq pir){
  WIN32_FIND_DATAA findData;
  DWORD handle;
  int i;
  char * redirPath;
  char * filename;
  unsigned char * filename2;
  srch_entry * se_en=pir->ir_data;
  
  switch (pir->ir_flags){ 
    case SEARCH_FIRST:
      UniToRedirPath(pir->ir_ppath,&redirPath);
      showMessage(MB_ASAP,&redirPath[0],"search in");
      pir->ir_error=(short)IFSR0FindFirstFile((short)pir->ir_attr,(char*)	pir->ir_upath,&findData,&handle);
      ///pir->ir_upath[0]=temp;
      if (pir->ir_error==0) {
        *((DWORD*)(se_en->se_key.sk_localFSD))=handle;
        se_en->se_attrib=(unsigned char)findData.dwFileAttributes;
        se_en->se_time=0;
        se_en->se_date=0;
        se_en->se_size =findData.nFileSizeLow;
        filename=&se_en->se_name[0];
        filename2=(unsigned char*)findData.cFileName;
        for (i=0;i<13;i++) 
          filename[i]=findData.cAlternateFileName[i];
      showMessage(MB_ASAP,&se_en->se_name[0],"found");
        pir->ir_firstclus=0;
        
  hfree((ULONG)redirPath);
        
      }
      break;
    case SEARCH_NEXT:
      pir->ir_error=(short)IFSR0FindNextFile(&findData,(DWORD)*((DWORD*)(se_en->se_key.sk_localFSD)));
      if (pir->ir_error==0) {
        se_en->se_attrib=(unsigned char)findData.dwFileAttributes;
        se_en->se_time=0;
        se_en->se_date=0;
        se_en->se_size =findData.nFileSizeLow;
        for (i=0;i<13;i++) 
          se_en->se_name[i]=findData.cAlternateFileName[i];
      showMessage(MB_ASAP,&se_en->se_name[0],"found");
        pir->ir_firstclus=0;
      }
      break;
    default: 
      pir->ir_error=1;
  }
  return pir->ir_error;
}
FS_FileDateTime(pioreq pir){
  switch (pir->ir_flags){
    case GET_MODIFY_DATETIME: pir->ir_dostime=((FileHandle*)pir->ir_fh)->writeTime;break;
    case GET_LAST_ACCESS_DATETIME : pir->ir_dostime=((FileHandle*)pir->ir_fh)->accessTime;break;
    case GET_CREATION_DATETIME: pir->ir_dostime=((FileHandle*)pir->ir_fh)->createTime;pir->ir_options =0;break;
  }
  pir->ir_error=0;
  return pir->ir_error;
}  
FS_FileAttributes(pioreq pir){
  char * redirPath;
  short temp;
  int tempsize;
  UniToRedirPath(pir->ir_ppath,&redirPath);
  pir->ir_error=0;
  
  switch(pir->ir_flags){
    case GET_ATTRIBUTES: 
      pir->ir_error=IFSR0GetFileAttributes(&redirPath[0],&temp); //DURCHLAUF!
      pir->ir_attr=temp;
    case GET_ATTRIB_COMP_FILESIZE: 
      pir->ir_error=GetFileSize(&redirPath[0],&tempsize);
      pir->ir_size=tempsize;
      break;
    case GET_ATTRIB_MODIFY_DATETIME:
      pir->ir_error=GetFileTimes(&redirPath[0],NULL,&pir->ir_dostime,NULL);
      pir->ir_options =0;
      break;
    case GET_ATTRIB_LAST_ACCESS_DATETIME :
      pir->ir_error=GetFileTimes(&redirPath[0],&pir->ir_dostime,NULL,NULL);
      pir->ir_options =0;
      break;
    case GET_ATTRIB_CREATION_DATETIME :
      pir->ir_error=GetFileTimes(&redirPath[0],NULL,NULL,&pir->ir_dostime);
      pir->ir_options =0;
      break;
  }  
  hfree((ULONG)redirPath);
  return pir->ir_error;
}
int FS_ReadFile(pioreq pir);

FS_OpenFile(pioreq pir){
  DWORD handle;
  WIN32_FIND_DATAA findData;
  char * redirPath;
  
  pir->ir_error=0;
  if ((pir->ir_flags & ACCESS_WRITEONLY)==ACCESS_WRITEONLY) pir->ir_error=87;
  if ((pir->ir_options & ACTION_CREATENEW)==ACTION_CREATENEW) pir->ir_error=87;
  if ((pir->ir_options & ACTION_CREATEALWAYS)==ACTION_CREATEALWAYS) pir->ir_error=87;
  if ((pir->ir_options & ACTION_REPLACEEXISTING)==ACTION_REPLACEEXISTING) pir->ir_error=87;

  if (pir->ir_error==0) {
    UniToRedirPath(pir->ir_ppath,&redirPath);
    pir->ir_error=(short)IFSR0OpenFile(&redirPath[0],R0_OPENCREATFILE/*_IN_CONTEXT*/,0x1000 | 0x2000 | 0 ,0,0x1,0,&handle,&pir->ir_options);
    if (pir->ir_error==0) {
      pir->ir_fh=halloc(sizeof(FileHandle),HEAPSWAP);
      ((FileHandle*)pir->ir_fh)->r0handle=handle;
      //get extended infos over the file (who need it??)
      pir->ir_error=(short)IFSR0FindFirstFile(/*FILE_ATTRIBUTE_EVERYTHING*/FILE_ATTRIBUTE_SYSTEM|FILE_ATTRIBUTE_HIDDEN|FILE_ATTRIBUTE_READONLY|FILE_ATTRIBUTE_ARCHIVE,&redirPath[0],&findData,&handle);
      if (pir->ir_error!=0) {
        SimpleMessage("error find first");
        IFSR0CloseFile(((FileHandle*)pir->ir_fh)->r0handle);
        hfree(pir->ir_fh);
        hfree((ULONG)redirPath);
        return pir->ir_error;
      }  
      pir->ir_error=(short)IFSR0FindCloseFile(handle);
      if (pir->ir_error!=0) {
        SimpleMessage("error find close");
        IFSR0CloseFile(((FileHandle*)pir->ir_fh)->r0handle);
        hfree(pir->ir_fh);
        hfree((ULONG)redirPath);
        return pir->ir_error;
      }  
      
      pir->ir_dostime.dt_date=0; //make what you want with this
      pir->ir_dostime.dt_time=0;
      pir->ir_size=findData.nFileSizeLow;
      pir->ir_attr=findData.dwFileAttributes;
      
      ((FileHandle*)pir->ir_fh)->size=pir->ir_size;
      pir->ir_hfunc->hf_misc=&fileopenfuncs;
      pir->ir_hfunc->hf_read=FS_ReadFile;
      pir->ir_hfunc->hf_write=FS_ErrorFunc;//WriteFile;
      hfree((ULONG)redirPath);
    }  
  }  else SimpleMessage("fileopen error");
  return pir->ir_error;
}  
FS_ReadFile(pioreq pir){
  int readCount;
  if (pir->ir_pos>((FileHandle*)pir->ir_fh)->size) {
      SimpleMessage("eof"); 
    pir->ir_length=0;
    pir->ir_error=38;
    return pir->ir_error;
  }  
  pir->ir_error=IFSR0ReadFile(*(DWORD*)pir->ir_fh,R0_READFILE,pir->ir_length,pir->ir_pos,  pir->ir_data,&readCount);

  if (pir->ir_error==0) {
    if (((FileHandle*)pir->ir_fh)->size<(pir->ir_pos+readCount)) {
      pir->ir_length=((FileHandle*)pir->ir_fh)->size - pir->ir_pos;
      pir->ir_pos=((FileHandle*)pir->ir_fh)->size;
    } else {  
      pir->ir_length=readCount;
      pir->ir_pos+=readCount;
    }  
  }  else {
    pir->ir_length=0;
  }
  return pir->ir_error;
}
FS_FileSeek(pioreq pir){
  switch (pir->ir_flags){
    case FILE_END:
      pir->ir_pos=((FileHandle*)pir->ir_fh)->size - pir->ir_pos;
      break;
  }
  
  pir->ir_error=0;
  return pir->ir_error;
}  

FS_CloseFile(pioreq pir){
  pir->ir_error=0;
  if (pir->ir_flags==CLOSE_FINAL){
    SimpleMessage("fileclosefinal");    
    IFSR0CloseFile(*(DWORD*)pir->ir_fh);
    hfree(pir->ir_fh);
  }
  pir->ir_pos=NULL;
  return pir->ir_error;
}  
FileSystemApiHookFunction(pIFSFunc FSDFnAddr, int FunctionNum, int Drive, int ResourceFlags, int CodePage, pioreq pir)
{  
  int temp,temp2,temp3;
  if (Drive==mountDrive) {
    switch (FunctionNum) {
      case IFSFN_FINDOPEN:
        return FS_FindFirstFile(pir);
      case IFSFN_FINDNEXT:
        return FS_FindNextFile(pir);
      case IFSFN_FINDCLOSE:
        return FS_FindClose(pir);
      case IFSFN_DIR:
        switch (pir->ir_flags) {
          case CREATE_DIR: showMessage(MB_ERROR,"Try to create a directory on an write-only device","CD-Rom Simulator"); return 1;break;
          case DELETE_DIR: showMessage(MB_ERROR,"Try to create a directory on an write-only device","CD-Rom Simulator"); return 1;break;
          case CHECK_DIR: 
            if (ExistDirectory((char*)(pir->ir_upath))) pir->ir_error=0;
            else pir->ir_error=1;
            return pir->ir_error;
          case QUERY83_DIR: 
            convertLastLFNElementToDOSUni(pir->ir_ppath,&pir->ir_ppath2,redirDrive);
            pir->ir_error=0;
            return pir->ir_error;
          case QUERYLONG_DIR: //this does *NOTHING*, a lfn prog can use dos files
            pir->ir_ppath2=pir->ir_ppath;
            pir->ir_error=0;
            return pir->ir_error;
        }
        break;
      case IFSFN_QUERY:
        temp=pir->ir_options;
        temp2=pir->ir_length;
        if (temp==2) {
          oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
          temp3=pir->ir_options;
          pir->ir_options=(short)temp;
          temp=temp3;

          temp3=pir->ir_length;
          pir->ir_length=temp2;
          temp2=temp3;
          temp3=FS_QueryResourceInfo(pir);
          pir->ir_options=(short)temp;
          pir->ir_length=temp2;
          return temp3;
        } else {
          return oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
        }  
      case IFSFN_SEARCH:  
        return FS_SearchFile(pir);
      case IFSFN_FILEATTRIB:
        return FS_FileAttributes(pir); 
      case IFSFN_OPEN:
        if (pir->ir_ppath!=NULL)
          return FS_OpenFile(pir);
         else
          return oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
          
      case IFSFN_READ:
        return FS_ReadFile(pir);
      case IFSFN_SEEK:
        return FS_FileSeek(pir); 
      case IFSFN_FILETIMES:
        return FS_FileDateTime(pir);
      case IFSFN_CLOSE:
        return FS_CloseFile(pir);
      case IFSFN_FCNCLOSE:case IFSFN_FCNNEXT:
        //this is ignored 
        pir->ir_error=0;
        writeLogFile("ignored",7);
        return 0;
      default:
        ShowIntMessage(MB_OK  | MB_SYSTEMMODAL | MB_ICONEXCLAMATION | MB_ASAP | MB_APPLMODAL,FunctionNum ,"CD Rom Simulator (unhandled Event)");
        return oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
    }
        return oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
  } else 
    return oldHook(FSDFnAddr, FunctionNum, Drive, ResourceFlags, CodePage, pir);
}

extern int __stdcall _CIoControl(DIOCPARAMETERS * deviceControl){
  switch (deviceControl->dwIoControlCode) {
    case 1:  //Mainfunction One, hook one Drive
      if (deviceControl->cbInBuffer<3) {
        showMessage(MB_OK | MB_SYSTEMMODAL | MB_ICONEXCLAMATION | MB_ASAP,"Invalid Buffersize, must be greater than 2 (test 1)","CD-Rom Simulator");
        return 1;
      }
      if (oldHook!=NULL) {
        showMessage(MB_OK | MB_SYSTEMMODAL | MB_ICONEXCLAMATION | MB_ASAP,"Already hooking","CD-Rom Simulator");
        return 2;
      }
      mountDrive = *(char*)(deviceControl->lpvInBuffer);
      redirDrive = *(char*)(deviceControl->lpvInBuffer+1);
      driveNameLen = *(char*)(deviceControl->lpvInBuffer+2);
      if (deviceControl->cbInBuffer!=(driveNameLen+3)) {
        showMessage(MB_OK | MB_SYSTEMMODAL | MB_ICONEXCLAMATION | MB_ASAP,"Invalid Buffersize, must be greater than 3 + 3rd byte (max 32) [wrong format: 1 byte cd, 1 byte real drive, 1 byte sim name len, name..","CD-Rom Simulator");
        return 1;
      };
      cpyStrN(&driveName[0],(char*)(deviceControl->lpvInBuffer+3),driveNameLen);
      driveName[driveNameLen]='\0';

      oldHook=IFSMgr_InstallFileSystemApiHookCWrap(&FileSystemApiHookFunction);
      break;
    case DIOC_OPEN: 
      initLogFile("C:\\logfile.txt");
      writeLogFile("test",4);
      writeLogFile("test2",5);
      oldHook=NULL;
      mutex=CreateMutex(0,0);

      fileopenfuncs.hm_version=IFS_VERSION;
      fileopenfuncs.hm_revision=IFS_REVISION;
      fileopenfuncs.hm_size=NUM_HNDLMISC;//FS_GetFileSize
      fileopenfuncs.hm_func[HM_SEEK]=FS_FileSeek;
      fileopenfuncs.hm_func[HM_CLOSE]=FS_CloseFile;
      fileopenfuncs.hm_func[HM_COMMIT]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_FILELOCKS]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_FILETIMES]=FS_FileDateTime;
      fileopenfuncs.hm_func[HM_PIPEREQUEST]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_HANDLEINFO]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_ENUMHANDLE]=FS_ErrorFunc;
      
      findfirstfuncs.hm_version=IFS_VERSION;
      findfirstfuncs.hm_revision=IFS_REVISION;
      findfirstfuncs.hm_size=IFS_VERSION;
      findfirstfuncs.hm_version=NUM_HNDLMISC;
      fileopenfuncs.hm_func[HM_SEEK]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_CLOSE]=FS_FindClose;
      fileopenfuncs.hm_func[HM_COMMIT]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_FILELOCKS]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_FILETIMES]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_PIPEREQUEST]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_HANDLEINFO]=FS_ErrorFunc;
      fileopenfuncs.hm_func[HM_ENUMHANDLE]=FS_ErrorFunc;
      break;
    case DIOC_CLOSEHANDLE:  
      closeLogFile();
      if (oldHook!=NULL) 
        IFSMgr_RemoveFileSystemApiHookCWrap(&FileSystemApiHookFunction);
      oldHook=NULL;

      break;
  }
  return 0;
}
extern void __stdcall _CInit(){
    return;
}  

extern void __stdcall _CExit(){
    return;
}  
